#ifndef _MY_DESK_H
#define _MY_DESK_H

//////////////////////
// test-app/MyDesk.H
//////////////////////
//
// OpDesk (Version 0.70)
// This file is part of the OpDesk node graph FLTK widget.
// Copyright (C) 2009 by Greg Ercolano.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA.
//

#include <FL/fl_ask.H>
#include "everything.H"
#include "MyButton.H"
#include "MyBox.H"

// CUSTOM Fl_OpDesk
//    Our app derives from the Fl_OpDesk widget to augment it with our app-specific code.
//
class MyDesk : public Fl_OpDesk {
    std::vector<MyBox*> box_clipboard;	// copy/paste clipboard for MyBox's

    // Fl_OpDesk calls this virtual when connection errors occur.
    //    Let's post a dialog instead of the default stderr behavior.
    //
    void ConnectionError(Fl_OpButton *src, Fl_OpButton *dst, std::string &errmsg);

public:
    MyDesk(int X,int Y,int W,int H,const char *L=0):Fl_OpDesk(X,Y,W,H,L) {
    }

    int SaveLayout(FILE *fp);
    int LoadLayout(FILE *fp, int &line, std::string &errmsg);
    int CopySelected();
    int PasteSelected();
};

#endif /*_MY_DESK_H*/
